Subject: Re: Fwd: [ofa-general] FW: QLogic vNIC Kernel Submission

From: Patrick McHardy <[email-masked]>
Date: Wed, 18 Jun 2008 13:19:22 +0200

Jeff Garzik wrote:
> Amar Mudrankit wrote:
>> ---------- Forwarded message ----------
>> From: John Russo <[email-masked]>
>> Date: Tue, Jun 17, 2008 at 6:36 PM
>> Subject: [ofa-general] FW: QLogic vNIC Kernel Submission
>> To: [email-masked]
>>
>>
>> It looks as if my original email was "scrubbed" before it made the
>> mailing list so I am resending it...
>>
>> QLogic has been attempting to submit our virtual NIC (vNIC) driver to
>> the Linux kernel for several months.  We have made changes to the code
>> based on the feedback we have received over four rounds of
>> submissions. Among the feedback we received during this process was a
>> request to alter our code to use a single value per file for
>> configuration of our driver through sysfs interface.  After spending
>> much time and effort to complete this change to our design we
>> re-submitted the driver only to receive a response suggesting that we
>> change once again from this interface to a different API interface
>> called rtnl_link.  Needless to say I am very frustrated with this
>> process. This new API interface would require substantial changes to
>> our code.
>>
>> QLogic has met the initial request to move to a single valued sysfs
>> interface and I would hope that this new request will be waived and
>> will not be a roadblock to inclusion of our driver to the kernel.
> 
> One option is to get the base driver into the tree, sans sysfs 
> interface, and wait for the netlink interface.
> 
> As Patrick noted, it is very important to -not- just throw new user 
> interfaces into the tree, because that essentially sets them in stone at 
> that point, needing to be supported as an Application Binary Interface 
> (ABI).
> 
> The other stuff, like duplication of existing interfaces and strange 
> FSM-based netdev registration, are problems that could be worked out 
> in-tree, I suppose.

That sounds fine to me. The duplication is even going away
automatically with removal of the sysfs interface.